import { AreaSeries as AreaSeries_2 } from '@devexpress/dx-react-chart';
import { ArgumentAxis as ArgumentAxis_2 } from '@devexpress/dx-react-chart';
import { BarSeries as BarSeries_2 } from '@devexpress/dx-react-chart';
import { Chart as Chart_2 } from '@devexpress/dx-react-chart';
import { Legend as Legend_2 } from '@devexpress/dx-react-chart';
import { LineSeries as LineSeries_2 } from '@devexpress/dx-react-chart';
import { PieSeries as PieSeries_2 } from '@devexpress/dx-react-chart';
import * as React_2 from 'react';
import { ScaleObject } from '@devexpress/dx-react-chart';
import { ScatterSeries as ScatterSeries_2 } from '@devexpress/dx-react-chart';
import { SeriesRef } from '@devexpress/dx-react-chart';
import { SplineSeries as SplineSeries_2 } from '@devexpress/dx-react-chart';
import { Title as Title_2 } from '@devexpress/dx-react-chart';
import { Tooltip as Tooltip_2 } from '@devexpress/dx-react-chart';
import { ValueAxis as ValueAxis_2 } from '@devexpress/dx-react-chart';
import { Viewport } from '@devexpress/dx-react-chart';
import { ZoomAndPan as ZoomAndPan_2 } from '@devexpress/dx-react-chart';

export declare namespace AreaSeries {
  /** Describes properties passed to a component that renders the series. */
  export type SeriesProps = AreaSeries_2.SeriesProps;
}

export declare namespace AreaSeries {
  /** Describes properties of a component that renders series. */
  export type PathSeriesProps = AreaSeries_2.PathSeriesProps;
}

/** The AreaSeries plugin visualizes the area series. */
export declare const AreaSeries: React_2.ComponentType<AreaSeriesProps> & {
  /** A component that renders series. */
  Path: React_2.ComponentType<AreaSeries_2.PathSeriesProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
};

export declare interface AreaSeriesProps {
  /** A series name. */
  name?: string;
  /** The name of a data field that provides series point values. */
  valueField?: string;
  /** The name of a data field that provides series point argument values. */
  argumentField?: string;
  /** An associated scale. */
  scaleName?: string;
  /** The series color. */
  color?: string;
  /** A component that renders series. */
  seriesComponent?: React_2.ComponentType<AreaSeries_2.SeriesProps>;
}

export declare namespace ArgumentAxis {
  /** Describes properties passed to a component that renders the axis's root layout. */
  export type RootProps = ArgumentAxis_2.RootProps;
}

export declare namespace ArgumentAxis {
  /** Describes properties passed to a component that renders the axis's line, ticks and grid. */
  export type LineProps = ArgumentAxis_2.LineProps;
}

export declare namespace ArgumentAxis {
  /** Describes properties passed to a component that renders the axis's label. */
  export type LabelProps = ArgumentAxis_2.LabelProps;
}

/** The ArgumentAxis plugin visualizes the argument axis. */
export declare const ArgumentAxis: React_2.ComponentType<ArgumentAxisProps> & {
  /** A component that renders the axis's root layout. */
  Root: React_2.ComponentType<ArgumentAxis_2.RootProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders the tick. */
  Tick: React_2.ComponentType<ArgumentAxis_2.LineProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders the axis's label. */
  Label: React_2.ComponentType<ArgumentAxis_2.LabelProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders the axis's line. */
  Line: React_2.ComponentType<ArgumentAxis_2.LineProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders the grid. */
  Grid: React_2.ComponentType<ArgumentAxis_2.LineProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
};

export declare interface ArgumentAxisProps {
  /** The tick size. */
  tickSize?: number;
  /** The axis position. */
  position?: 'bottom' | 'top' | 'left' | 'right';
  /** The indent from the axis. */
  indentFromAxis?: number;
  /** A function that returns a tick formatter function. */
  tickFormat?: (scale: ScaleObject) => (tick: string) => string;
  /** Specifies whether to render ticks. */
  showTicks?: boolean;
  /** Specifies whether to render the grid. */
  showGrid?: boolean;
  /** Specifies whether to render the axis's line. */
  showLine?: boolean;
  /** Specifies whether to render the axis's labels. */
  showLabels?: boolean;
  /** A component that renders the axis's root layout. */
  rootComponent?: React_2.ComponentType<ArgumentAxis_2.RootProps>;
  /** A component that renders a tick. */
  tickComponent?: React_2.ComponentType<ArgumentAxis_2.LineProps>;
  /** A component that renders the axis's label. */
  labelComponent?: React_2.ComponentType<ArgumentAxis_2.LabelProps>;
  /** A component that renders the axis's line. */
  lineComponent?: React_2.ComponentType<ArgumentAxis_2.LineProps>;
  /** A component that renders the grid. */
  gridComponent?: React_2.ComponentType<ArgumentAxis_2.LineProps>;
}

export declare namespace BarSeries {
  /** Describes properties passed to a component that renders a bar. */
  export type PointProps = BarSeries_2.PointProps;
}

/** The BarSeries plugin visualizes the bar series. */
export declare const BarSeries: React_2.ComponentType<BarSeriesProps> & {
  /** A component that renders a bar. */
  Point: React_2.ComponentType<BarSeries_2.PointProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
};

export declare interface BarSeriesProps {
  /** The series name. */
  name?: string;
  /** The name of a data field that provides series point values. */
  valueField?: string;
  /** The name of a data field that provides series point argument values. */
  argumentField?: string;
  /** An associated scale. */
  scaleName?: string;
  /** The bar width in relative units. */
  barWidth?: number;
  /** The series color. */
  color?: string;
  /** A component that renders a bar. */
  pointComponent?: React_2.ComponentType<BarSeries_2.PointProps>;
}

export declare namespace Chart {
  /** Describes properties passed to a component that renders the chart root layout. */
  export type RootProps = Chart_2.RootProps;
}

export declare namespace Chart {
  /** Describes properties passed to a component that renders the chart's label. */
  export type LabelProps = Chart_2.LabelProps;
}

/** The Chart is a root container component designed to process and display data specified via the `data` property. The Chart's functionality  is implemented in several plugins specified as child components. */
export declare const Chart: React_2.ComponentType<ChartProps> & {
  /** A component that renders the chart's label. */
  Label: React_2.ComponentType<Chart_2.LabelProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
};

export declare interface ChartProps {
  /** An array containing custom data. */
  data?: Array<any>;
  /** Chart width. */
  width?: number;
  /** Chart height. */
  height?: number;
  /** Rotates the chart. */
  rotated?: boolean;
  /** A component that renders the chart's root layout. */
  rootComponent?: React_2.ComponentType<Chart_2.RootProps>;
}

export declare namespace Legend {
  /** Describes properties passed to a component that renders the label. */
  export type LabelProps = Legend_2.LabelProps;
}

export declare namespace Legend {
  /** Describes properties passed to a component that renders the legend's root layout. */
  export type RootProps = Legend_2.RootProps;
}

export declare namespace Legend {
  /** Describes properties passed to a component that renders a legend item. */
  export type ItemProps = Legend_2.ItemProps;
}

/** The Legend plugin visualizes the legend. */
export declare const Legend: React_2.ComponentType<LegendProps> & {
  /** A component that renders the root layout. */
  Root: React_2.ComponentType<Legend_2.RootProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders an item. */
  Item: React_2.ComponentType<Legend_2.ItemProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a marker. */
  Marker: React_2.ComponentType<object & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders the label. */
  Label: React_2.ComponentType<Legend_2.LabelProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
};

export declare interface LegendProps {
  /** A component that renders a marker. */
  markerComponent?: React_2.ComponentType<object>;
  /** A component that renders the legend label. */
  labelComponent?: React_2.ComponentType<Legend_2.LabelProps>;
  /** A component that renders the legend's root layout. */
  rootComponent?: React_2.ComponentType<Legend_2.RootProps>;
  /** A component that renders a legend item. */
  itemComponent?: React_2.ComponentType<Legend_2.ItemProps>;
  /** The legend position. */
  position?: 'left' | 'right' | 'top' | 'bottom';
}

export declare namespace LineSeries {
  /** Describes properties passed to a component that renders series. */
  export type SeriesProps = LineSeries_2.SeriesProps;
}

export declare namespace LineSeries {
  /** Describes properties of a component that renders series. */
  export type PathSeriesProps = LineSeries_2.PathSeriesProps;
}

/** The LineSeries plugin visualizes the line series. */
export declare const LineSeries: React_2.ComponentType<LineSeriesProps> & {
  /** A component that renders series. */
  Path: React_2.ComponentType<LineSeries_2.PathSeriesProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
};

export declare interface LineSeriesProps {
  /** The series name. */
  name?: string;
  /** The name of a data field that provides series point values. */
  valueField?: string;
  /** The name of a data field that provides series point argument values. */
  argumentField?: string;
  /** An associated scale. */
  scaleName?: string;
  /** The series color. */
  color?: string;
  /** A component that renders series. */
  seriesComponent?: React_2.ComponentType<LineSeries_2.SeriesProps>;
}

export declare namespace PieSeries {
  /** Describes properties passed to a component that renders the slice. */
  export type PointProps = PieSeries_2.PointProps;
}

/** The PieSeries plugin visualizes pie series. */
export declare const PieSeries: React_2.ComponentType<PieSeriesProps> & {
  /** A component that renders a slice. */
  Point: React_2.ComponentType<PieSeries_2.PointProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
};

export declare interface PieSeriesProps {
  /** A series name. */
  name?: string;
  /** The name of a data field that provides series point values. */
  valueField?: string;
  /** The name of a data field that provides series point argument values. */
  argumentField?: string;
  /** The inner radius in relative units. */
  innerRadius?: number;
  /** The outer radius in relative units. */
  outerRadius?: number;
  /** A component that renders a slice. */
  pointComponent?: React_2.ComponentType<PieSeries_2.PointProps>;
}

export declare namespace ScatterSeries {
  /** Describes properties passed to a component that renders the point. */
  export type PointProps = ScatterSeries_2.PointProps;
}

export declare namespace ScatterSeries {
  /** Describes properties passed to a component that renders the series. */
  export type SeriesProps = ScatterSeries_2.SeriesProps;
}

/** The ScatterSeries plugin visualizes the scatter series. */
export declare const ScatterSeries: React_2.ComponentType<ScatterSeriesProps> & {
  /** A component that renders the series of points. */
  Path: React_2.ComponentType<ScatterSeries_2.SeriesProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a series point. */
  Point: React_2.ComponentType<ScatterSeries_2.PointProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
};

export declare interface ScatterSeriesProps {
  /** A series name. */
  name?: string;
  /** The name of a data field that provides series point values. */
  valueField?: string;
  /** The name of a data field that provides series point argument values. */
  argumentField?: string;
  /** The associated scale. */
  scaleName?: string;
  /** Point options. */
  point?: { size : number };
  /** A series color. */
  color?: string;
  /** A component that renders a series point. */
  pointComponent?: React_2.ComponentType<ScatterSeries_2.PointProps>;
}

export declare namespace SplineSeries {
  /** Describes properties passed to a component that renders series. */
  export type SeriesProps = SplineSeries_2.SeriesProps;
}

export declare namespace SplineSeries {
  /** Describes properties of a component that renders series. */
  export type PathSeriesProps = SplineSeries_2.PathSeriesProps;
}

/** The SplineSeries plugin visualizes the spline series. */
export declare const SplineSeries: React_2.ComponentType<SplineSeriesProps> & {
  /** A component that renders series. */
  Path: React_2.ComponentType<SplineSeries_2.PathSeriesProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
};

export declare interface SplineSeriesProps {
  /** The series name. */
  name?: string;
  /** The name of a data field that provides series point values. */
  valueField?: string;
  /** The name of a data field that provides series point argument values. */
  argumentField?: string;
  /** An associated scale. */
  scaleName?: string;
  /** The series color. */
  color?: string;
  /** A component that renders series. */
  seriesComponent?: React_2.ComponentType<SplineSeries_2.SeriesProps>;
}

export declare namespace Title {
  /** Describes properties passed to a component that renders the title. */
  export type TextProps = Title_2.TextProps;
}

/** The Title plugin renders the chart title. */
export declare const Title: React_2.ComponentType<TitleProps> & {
  /** A component that renders the title. */
  Text: React_2.ComponentType<Title_2.TextProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
};

export declare interface TitleProps {
  /** A component that renders the title. */
  textComponent?: React_2.ComponentType<Title_2.TextProps>;
  /** The title text. */
  text?: string;
  /** The title position. */
  position?: 'top' | 'bottom';
}

export declare namespace Tooltip {
  /** Describes properties passed to a component that renders the tooltip. */
  export type OverlayProps = Tooltip_2.OverlayProps;
}

export declare namespace Tooltip {
  /** Describes properties passed to a component that renders the tooltip's content. */
  export type ContentProps = Tooltip_2.ContentProps;
}

export declare namespace Tooltip {
  /** Describes properties passed to a component that renders the tooltip's arrow. */
  export type ArrowProps = Tooltip_2.ArrowProps;
}

export declare namespace Tooltip {
  /** Describes properties passed to a component that renders the tooltip's sheet. */
  export type SheetProps = Tooltip_2.SheetProps;
}

/** The `Tooltip` plugin implements a tooltip that shows information about a point. The tooltip appears when a user hovers the mouse pointer over a series point. */
export declare const Tooltip: React_2.ComponentType<TooltipProps> & {
  /** A component that renders the tooltip. */
  Overlay: React_2.ComponentType<Tooltip_2.OverlayProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders the tooltip's content. */
  Content: React_2.ComponentType<Tooltip_2.ContentProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders the tooltip arrow. */
  Arrow: React_2.ComponentType<Tooltip_2.ArrowProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders the tooltip sheet. */
  Sheet: React_2.ComponentType<Tooltip_2.SheetProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
};

export declare interface TooltipProps {
  /** An item for which the tooltip is displayed initially. */
  defaultTargetItem?: SeriesRef;
  /** An item for which the tooltip is displayed. */
  targetItem?: SeriesRef;
  /** A function that is executed when the target item changes. */
  onTargetItemChange?: (target: SeriesRef) => void;
  /** A component that renders the tooltip. */
  overlayComponent?: React_2.ComponentType<Tooltip_2.OverlayProps>;
  /** A component that renders the tooltip content. */
  contentComponent?: React_2.ComponentType<Tooltip_2.ContentProps>;
  /** A component that renders the tooltip arrow. */
  arrowComponent?: React_2.ComponentType<Tooltip_2.ArrowProps>;
  /** A component that renders the tooltip sheet. */
  sheetComponent?: React_2.ComponentType<Tooltip_2.SheetProps>;
}

export declare namespace ValueAxis {
  /** Describes properties passed to a component that renders the axis root layout. */
  export type RootProps = ValueAxis_2.RootProps;
}

export declare namespace ValueAxis {
  /** Describes properties passed to a component that renders the axis's line, ticks and grid. */
  export type LineProps = ValueAxis_2.LineProps;
}

export declare namespace ValueAxis {
  /** Describes properties passed to a component that renders the axis label. */
  export type LabelProps = ValueAxis_2.LabelProps;
}

/** The ValueAxis plugin visualizes the value axis. */
export declare const ValueAxis: React_2.ComponentType<ValueAxisProps> & {
  /** A component that renders the axis root layout. */
  Root: React_2.ComponentType<ValueAxis_2.RootProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders the tick. */
  Tick: React_2.ComponentType<ValueAxis_2.LineProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders the axis label. */
  Label: React_2.ComponentType<ValueAxis_2.LabelProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders the axis line. */
  Line: React_2.ComponentType<ValueAxis_2.LineProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders the grid. */
  Grid: React_2.ComponentType<ValueAxis_2.LineProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
};

export declare interface ValueAxisProps {
  /** The tick size. */
  tickSize?: number;
  /** The axis position. */
  position?: 'bottom' | 'top' | 'left' | 'right';
  /** The scale name. */
  scaleName?: string;
  /** The indent from the axis. */
  indentFromAxis?: number;
  /** A function that returns a tick formatter function. */
  tickFormat?: (scale: ScaleObject) => (tick: string) => string;
  /** Specifies whether to render ticks. */
  showTicks?: boolean;
  /** Specifies whether to render the grid. */
  showGrid?: boolean;
  /** Specifies whether to render the axis's line. */
  showLine?: boolean;
  /** Specifies whether to render the axis's labels. */
  showLabels?: boolean;
  /** A component that renders the axis root layout. */
  rootComponent?: React_2.ComponentType<ValueAxis_2.RootProps>;
  /** A component that renders a tick. */
  tickComponent?: React_2.ComponentType<ValueAxis_2.LineProps>;
  /** A component that renders the axis label. */
  labelComponent?: React_2.ComponentType<ValueAxis_2.LabelProps>;
  /** A component that renders the axis line. */
  lineComponent?: React_2.ComponentType<ValueAxis_2.LineProps>;
  /** A component that renders the grid. */
  gridComponent?: React_2.ComponentType<ValueAxis_2.LineProps>;
}

export declare namespace ZoomAndPan {
  /** Describes properties passed to a component that renders the rectangle around the area a user zooms with the mouse drag gesture. */
  export type DragBoxProps = ZoomAndPan_2.DragBoxProps;
}

/** The `ZoomAndPan` plugin allows you to set the chart's viewport and change it in response to mouse and touch events. */
export declare const ZoomAndPan: React_2.ComponentType<ZoomAndPanProps> & {
  /** A component that renders the rectangle that appears when a user zooms a region. */
  DragBox: React_2.ComponentType<ZoomAndPan_2.DragBoxProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
};

export declare interface ZoomAndPanProps {
  /** The default viewport. */
  defaultViewport?: Viewport;
  /** The viewport. */
  viewport?: Viewport;
  /** A function that is executed when the viewport changes. */
  onViewportChange?: (viewport: Viewport) => void;
  /** The type of interaction available for the argument scale. */
  interactionWithArguments?: 'none' | 'pan' | 'zoom' | 'both';
  /** The type of interaction available for the value scale. */
  interactionWithValues?: 'none' | 'pan' | 'zoom' | 'both';
  /** The key the allows a user to zoom a region by selecting it with the mouse drag gesture. */
  zoomRegionKey?: 'shift' | 'alt' | 'ctrl';
  /** A component that renders the rectangle that appears when a user zooms a region. */
  dragBoxComponent?: React_2.ComponentType<ZoomAndPan_2.DragBoxProps>;
}

export { }
